/* This program add two polynomial's P and Q, and resultant polynomial is R. The polynomails P, Q, and R in three variables is represented by the linked linear lists p, q, and r. The pinsert function insert polynomial p and q terms in ordered manne
r and this function invoke the findloc function to find the location of the new term. The function poly3add add two polynomials p and q by invoking function polylast and copy.
P = x3y2 + x2 + z2 and Q = -x3y2 + xz3 + y3z3*/

#include<stdio.h>
#include<malloc.h>
#include<conio.h>

struct nodetype{
	int powerx;
	int powery;
	int powerz;
	int coef;
	struct nodetype *next;
}*p,*q,*r, *newnode;
struct nodetype *pinsert(struct nodetype *, int, int, int, int);
struct nodetype *findloc(struct nodetype *, int, int, int);
struct nodetype *poly3add(struct nodetype *, struct nodetype *);
struct nodetype *polylast(struct nodetype *, int, int, int, int);
struct nodetype *copy(struct nodetype *, struct nodetype *);
void display(struct nodetype *);

void main()
{
	p = NULL;	/* Initially polynomail P is empty */
	q = NULL;	/* Initially polynomail Q is empty */
	r = NULL;	/* Initially sum polynomail R is empty */

	p=pinsert(p,2, 0, 0, 1);
	p=pinsert(p,3, 2, 0,1);
	p=pinsert(p,0 ,0, 2, 1);
	q=pinsert(q,3, 2 , 0,-1);
	q=pinsert(q,0,3, 3,1);
	q=pinsert(q,1,0,3,1);

	r = poly3add(p, q);
	printf("\n Polynomial P ");
	display(p);
	printf("\n Polynomial Q ");
	display(q);
	printf("\n Polynomial R = P + Q ");
	display(r);
}  /* End of main function */

/*function pinsert, insert into ordered list of 3 variables polynomial */
struct nodetype *pinsert(struct nodetype *start, int x,int y, int z,int c)
{
	struct nodetype *loc;
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->powery = y;
	newnode->powerz = z;
	newnode->coef = c;
	loc = findloc(start, x, y, z);
	if (loc ==NULL)
	{
		newnode->next = start;
		start = newnode;
	}
	else
	{
		newnode->next = loc->next;
		loc->next = newnode;
	}
	return (start);
}/* end of the pinsert function*/

/*function findloc return the address of the node succeeding */
struct nodetype *findloc(struct nodetype *start, int x, int y, int z)
{
	struct nodetype *prevptr, *ptr;
	int a, b, c;

	if (start ==NULL)
	   return (NULL);
	a = start->powerx;
	b = start->powery;
	c = start->powerz;
	if ((x >a) || ((x ==a) && (y >b)) || ((x ==a) && (y == b) && (z >c)))
		return (NULL);
	ptr = start;
	while (ptr->next!=NULL)
	{
		a = ptr->next->powerx;
		b = ptr->next->powery;
		c = ptr->next->powerz;

		if ((x <a) || ((x ==a) && (y <b)) || ((x ==a) && (y == b) && (z <c)))
		   ptr = ptr->next;
		else
			break;
	}
return (ptr);
} /* End of findloc function */

/*function poly3add, adds terms of two polynomials of three variables */
struct nodetype *poly3add(struct nodetype *p, struct nodetype *q)
{
	int a1, a2, b1, b2, c1, c2, d1, d2;
	struct nodetype *ptrp, *ptrq, *ptrr;
	ptrr = r;
	ptrp = p;
	ptrq = q;

	while ((ptrp !=NULL) && (ptrq !=NULL))
	{
		a1 = ptrp->powerx;
		a2 = ptrq->powerx;
		b1 = ptrp->powery;
		b2 = ptrq->powery;
		c1 = ptrp->powerz;
		c2 = ptrq->powerz;
		d1 = ptrp->coef;
		d2 = ptrq->coef;

		if ((a1 == a2) &&(b1 == b2) &&(c1 == c2))
		{
			if ((d1 +d2) != 0)
				ptrr = polylast(ptrr, a1, b1, c1, d1 + d2);
			ptrp = ptrp->next;
			ptrq = ptrq->next;

		}
		else if ((a1>a2)||((a1==a2)&&(b1>b2))||((a1==a2)&&(b1==b2)&&(c1>c2)))
			{
			ptrr = polylast(ptrr, a1, b1, c1, d1);
			ptrp = ptrp->next;
			}
			else
			{
			ptrr = polylast(ptrr, a2, b2, c2, d2);
			ptrq = ptrq->next;
			}
	}
	if (ptrp != NULL)
		  ptrr = copy (ptrp, ptrr);
	else
		  ptrr = copy (ptrq, ptrr);
	return (r);
}   /* end of the poly3add function */

struct nodetype *polylast(struct nodetype *ptrr, int x, int y, int z, int c)
{
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->powery = y;
	newnode->powerz = z;
	newnode->coef = c;

	if (ptrr ==NULL)
		r = newnode;
	else
		ptrr->next =newnode;

	newnode->next = NULL;
	return (newnode);
}/* end of the polylast function*/

struct nodetype *copy(struct nodetype *ptr, struct nodetype *ptrr)
{
	int a, b, c, d;
	a = ptr->powerx;
	b = ptr->powery;
	c = ptr->powerz;
	d = ptr->coef;

	while (ptr !=NULL)
	{
		ptrr = polylast(ptrr, a, b, c, d);
		ptr  = ptr->next;
	}
	return (ptrr);
}   /* end of the copy function*/
/*function display, displays the terms of resultant polynomial */
void display(struct nodetype *start)
{
	struct nodetype *ptr;
	int a, b, c, d;
	ptr=start;
	printf("\n powerx powery powerz coef");
	while(ptr!=NULL)
	{
		a = ptr->powerx;
		b = ptr->powery;
		c = ptr->powerz;
		d = ptr->coef;

		printf("\n %d\t %d\t %d\t %d",a, b, c, d );
		ptr = ptr->next;
	}
}   /*end of the display function */
