/* This program inserts a polynomial in three variables. The polynomial x2y2z2 + x3y2 + z2 is inserted. The function pinsert construct the linked representations of these polynomials. Each term consist of four input, the first three correspond to the powers of x, y, and z, and the fourth to the coefficient of the term. This function invoke a findloc function
which return the location of the new term. */

#include<stdio.h>
#include<malloc.h>
#include<conio.h>

struct nodetype{
	int powerx;
	int powery;
	int powerz;
	int coef;
	struct nodetype *next;
}*p, *newnode;
struct nodetype *pinsert(struct nodetype *, int, int, int, int);
struct nodetype *findloc(struct nodetype *, int, int, int);
void display(struct nodetype *);

void main()
{
	p = NULL;	/* Initially polynomail p list is empty */
	p=pinsert(p,2, 2, 2, 1);
	p=pinsert(p,3, 2, 0,1);
	p=pinsert(p,0 ,0, 2, 1);
	printf("\n Polynomial P ");
	display(p);
}  /* End of the main function */

/*function pinsert, insert term into a ordered linear list*/
struct nodetype *pinsert(struct nodetype *start, int x,int y, int z,int c)
{
	struct nodetype *loc;
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->powery = y;
	newnode->powerz = z;
	newnode->coef = c;
	loc = findloc(start, x, y, z);
	if (loc ==NULL)
	{
		newnode->next = start;
		start = newnode;
	}
	else
	{
		newnode->next = loc->next;
		loc->next = newnode;
	}

	return (start);
}/* end of the pinsert function*/

/*Function findloc, return the address of the node succeeding */
struct nodetype *findloc(struct nodetype *start, int x, int y, int z)
{
	struct nodetype *ptr;
	int a, b, c;

	if (start ==NULL)
	   return (NULL);
	a = start->powerx;
	b = start->powery;
	c = start->powerz;
	if ((x >a) || ((x ==a) && (y >b)) || ((x ==a) && (y == b) && (z >c)))
		return (NULL);
	ptr 	=start;
	while (ptr->next!=NULL)
	{
		a = ptr->next->powerx;
		b = ptr->next->powery;
		c = ptr->next->powerz;

		if ((x <a) || ((x ==a) && (y <b)) || ((x ==a) && (y == b) && (z <c)))
			ptr = ptr->next;
		else
			break;
	}
	return (ptr);
}   /* End of the findloc function */

/*function display, displays each term of the polynomial */
void display(struct nodetype *start)
{
	struct nodetype *ptr;
	int a, b, c, d;
	ptr=start;
	printf("\n powerx powery powerz coef");
	while(ptr!=NULL)
	{
		a = ptr->powerx;
		b = ptr->powery;
		c = ptr->powerz;
		d = ptr->coef;
		printf("\n %d\t %d\t %d\t %d",a, b, c, d );
		ptr = ptr->next;
	}
}  /* End of the display function */
