/* This program add two polynomials P and Q, and resultant polynomial is R.
The polynomial's P, Q, and R in one variable is represented by the linked
linear lists p, q, and r. The pinsert function insert polynomial p and q terms
in ordered manner and this function invoke the findloc function to find the
location of the new term. The function polyadd add two polynomials p and q by
invoking function polylast and copy. P = 3x4 + 2x3 + 2 and Q = 2x6 -2x3 + 2x*/

#include<stdio.h>
#include<malloc.h>
#include<stdlib.h>
#include<conio.h>

struct nodetype{
	int powerx;
	int coef;
	struct nodetype *next;
	}*p,*q,*r, *newnode;
	struct nodetype *pinsert(struct nodetype *, int, int);
	struct nodetype *findloc(struct nodetype *, int);
	struct nodetype *polyadd(struct nodetype *, struct nodetype *);
	struct nodetype *polylast(struct nodetype *, int, int);
	struct nodetype *copy(struct nodetype *, struct nodetype *);

	void display(struct nodetype *);
void main()
{
	p = NULL;	/* Initially polynomail p is empty */
	q = NULL;	/* Initially polynomail q  is empty */
	r = NULL;	/* Initially sum polynomail r is empty */
	p=pinsert(p,4, 3);
	p=pinsert(p,3, 2);
	p=pinsert(p,0 ,2);
	q=pinsert(q,3, -2);
	q=pinsert(q,1, 2);
	q=pinsert(q,6, 2);

	r = polyadd(p, q);
	printf("\n Polynomial P ");
	display(p);
	printf("\n Polynomial Q ");
	display(q);
	printf("\n Polynomial R = P + Q ");
	display(r);
	getch();
}  /* End of main function */

struct nodetype *pinsert(struct nodetype *start, int x, int c)
{
	struct nodetype *loc;
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->coef = c;
	loc = findloc(start, x);
	if (loc ==NULL)
	{
		newnode->next = start;
		start = newnode;
	}
	else
	{
		newnode->next = loc->next;
		loc->next = newnode;
	}
return (start);
}/* end of the pinsert function*/

struct nodetype *findloc(struct nodetype *start, int x)
{
	struct nodetype *prevptr, *ptr;
	if (start ==NULL)
	   return (NULL);
	if (x >start->powerx)
		return (NULL);
	prevptr =start;
	ptr 	=start->next;
	while (ptr!=NULL)
	{
		if (x > ptr->powerx)
			return (prevptr);
		prevptr =ptr;
		ptr = ptr->next;
	}
return (prevptr);
} /* End of findloc function */

struct nodetype *polyadd(struct nodetype *p, struct nodetype *q)
{
	struct nodetype *ptrp, *ptrq, *ptrr;
	ptrr = r;
	ptrp = p;
	ptrq = q;

	while ((ptrp !=NULL) && (ptrq !=NULL))
	{
		if (ptrp->powerx == ptrq->powerx)
		{
			if ((ptrp->coef + ptrq->coef) != 0)
				ptrr = polylast(ptrr, ptrp->powerx, ptrp->coef + ptrq->coef);
			ptrp = ptrp->next;
			ptrq = ptrq->next;

		}
		else if (ptrp->powerx > ptrq->powerx)
			{
			ptrr = polylast(ptrr, ptrp->powerx, ptrp->coef);
			ptrp = ptrp->next;
			}
			else
			{
			ptrr = polylast(ptrr, ptrq->powerx, ptrq->coef);
			ptrq = ptrq->next;
			}
	}
	if (ptrp != NULL)
		  ptrr = copy (ptrp, ptrr);
	else
		  ptrr = copy (ptrq, ptrr);
return (r);
} /* End of polyadd function */

struct nodetype *polylast(struct nodetype *ptrr, int x, int c)
{
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->coef = c;
	if (ptrr ==NULL)
		r = newnode;
	else
		ptrr->next =newnode;

	newnode->next = NULL;
return (newnode);
} /* End of polylast function */

struct nodetype *copy(struct nodetype *ptr, struct nodetype *ptrr)
{
		while (ptr !=NULL)
		{
			ptrr = polylast(ptrr, ptr->powerx, ptr->coef);
			ptr  = ptr->next;
		}
return (ptrr);
} /* End of the copy function */

void display(struct nodetype *start)
{
	struct nodetype *ptr;
	ptr=start;
	printf("\n powerx coef");
	while(ptr!=NULL)
	{
		printf("\n %d\t %d", ptr->powerx, ptr->coef );
		ptr = ptr->next;
	}
}   /* End of the display function */
