/* This program insert a polynomial 3x2 + 20x + 2 in a single variable.
The function pinsert construct the linked representations of these polynomails.
Each term consist of two input, the first input correspond to the powers of x
and the second to the coefficient of the term. This function invokes a
findloc function which return the location of the new term in the ordered
list. */

#include<stdio.h>
#include<malloc.h>
#include<conio.h>

struct nodetype{
	int powerx;
	int coef;
	struct nodetype *next;
	}*p,*q,*r, *newnode;
	struct nodetype *pinsert(struct nodetype *, int, int);
	struct nodetype *findloc(struct nodetype *, int);
	void display(struct nodetype *);
void main()
{
	p = NULL;	/* Initially polynomail list is empty */
	p=pinsert(p,2, 3);
	p=pinsert(p,1, 20);
	p=pinsert(p,0 ,2);
	printf("\n Polynomial P ");
	display(p);
} /* End of the main function */

/*function pinsert inserts after node with given address location */
struct nodetype *pinsert(struct nodetype *start, int x, int c)
{
	struct nodetype *loc;
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->powerx = x;
	newnode->coef = c;
	loc = findloc(start, x);
	if (loc ==NULL)
	{
		newnode->next = start;
		start = newnode;
	}
	else
	{
		newnode->next = loc->next;
		loc->next = newnode;
	}
return (start);
}/* end of the pinsert function*/

/* funtion findloc searches the given node in the list */
struct nodetype *findloc(struct nodetype *start, int x)
{
	struct nodetype *prevptr, *ptr;
	if (start ==NULL)
	   return (NULL);
	if (x >start->powerx)
		return (NULL);
	prevptr =start;
	ptr 	=start->next;
	while (ptr!=NULL)
	{
		if (x > ptr->powerx)
			return (prevptr);
		prevptr =ptr;
		ptr = ptr->next;
	}
return (prevptr);
}/* End of the findloc function */

/*function display, displays each term of the polynomial */
void display(struct nodetype *start)
{
	struct nodetype *ptr;
	ptr=start;
	printf("\n powerx coef");
	while(ptr!=NULL)
	{
		printf("\n %d\t %d", ptr->powerx , ptr->coef);
		ptr = ptr->next;
	}
}   /* End of the display function */
