/* Program deque.cpp to implement double ended queue operations using circular array deque. Program perform insertions and deletions from both end of the queue which is represented by left and right pointer variable*/

#include<stdio.h>
#include<conio.h>
#define MAXSIZE 5
int deque[MAXSIZE];
int right=-1;
int left=-1;

void insdeque(int, int);
int deldeque(int);
void display();

/* Function insdeque insert an element into left or right end  of deque */
void insdeque(int x, int f)
{
/* check for deque full */
if (left ==right+1)
 {
  printf("Queue full\n");
  return;
 }
else
{
 if (left == -1)
 { left =0; right = 0; deque[left] =x; return; }
 else if (f==1)
	{
	 right = (right+1) % MAXSIZE;
	 deque[right] = x;
	 }
   else
   {
   if (left == 0)
	   left = MAXSIZE -1;
	else
	   left = left -1;
	deque[left] = x;
   }
}
} /* End of insdeque function */

/*Function deldeque delete an element from left or right end of the deque*/
int deldeque(int f)
{
 int x;
 if (left==-1)
	{
	 printf(" Queue is empty\n");
	 return -1;
	}
 if (left == right)
 {x = deque[left]; left = -1; right =-1;}
 else
   {
   if (f==0)
   {
   x =deque[left];
   left = (left +1) % MAXSIZE;
   }
   else
   {
   x = deque[right];
   if (right ==0)
	   right =  MAXSIZE -1;
   else
	  right = right -1;
   }
 }
return x;
}

void display()
{
 int i;
 printf("\n Elements is deque:\n");
 if (left != -1)
  if (left <= right)
   for( i=left;i<=right;i++)
	printf(" %d      ",deque[i]);
  else
  {
  for( i=left;i<MAXSIZE;i++)
   printf("%d      ",deque[i]);
  for( i=0;i<=right;i++)
   printf("%d      ",deque[i]);
  }
} /* end of function */


void main()
 {
	int ch,t;
   do{
	printf("\n DEQUE (Double Ended QUEue):-- Opertions ");
	printf(" \n 1. Insert in left \n 2. Insert in right \n 3. Delete in left\n");
	printf(" 4. Delete in right\n 5. Display elements \n 6. Exit.\n");
	scanf("%d",&ch);
	switch(ch)
	{
	 case 1:
		 printf("enter data ");
		 scanf("%d",&t);
		 insdeque(t,0);
		 break;
	 case 2:
		 printf("enter data ");
		 scanf("%d",&t);
		 insdeque(t,1);
		 break;
	 case 3:
		 deldeque(0);
		 break;
	 case 4:
		 deldeque(1);
		 break;
	 case 5:
		 display();
		 break;
	 case 6:break;
	 } /* end of switch */
  }while(ch<6);    /* end of do -while */
} /* end of main() */
