/* Program freelist.cpp implement the dynamic contiguous memory
allocation scheme first fit, best fit and worst fit with the help of linked list.
The list of free blocks is maintained and allocated using linked list. */

#include<stdio.h>
#include<malloc.h>
struct nodetype{
	int size;
	struct nodetype *next;
}*ptr,*freeblk,*newnode, *alloc;

int item=0;
struct nodetype *createlist(struct nodetype *);
void firstfit(int);
void bestfit(int);
void worstfit(int);
void display(struct nodetype *);

void main()
{
	int ch,blk;
	freeblk	 = NULL;	/* Initially list is empty */
	printf("\n Program  for dynamic memory allocation");
	do{
		printf("\n 1. Create a Free Memory Blocks List");
		printf("\n 2. First fit ");
		printf("\n 3. Best fit ");
		printf("\n 4. Worst fit ");
		printf("\n 5. List of free blocks ");
		printf("\n 6. Exit ");
		printf("\n  Enter your choice ");
		scanf("%d",&ch);
		switch(ch)
		{
		case 1: freeblk =createlist(freeblk);
				 display(freeblk);
				 break;
		case 2: printf("\n Enter list of memory blocks request [type -1 for termination] ");
				do{
				scanf("%d",&blk);
				if (blk >0)
					firstfit(blk);
				}while(blk!=-1);
				display(freeblk);
				break;
		case 3: printf("\n Enter list of memory blocks request [type -1 for termination]");
				do{
				scanf("%d",&blk);
				if (blk >0)
					bestfit(blk);
				}while(blk!=-1);
				display(freeblk);
				break;
		case 4: printf("\n Enter list of memory blocks request [type -1 for termination]");
				do{
				scanf("%d",&blk);
				if (blk >0)
					worstfit(blk);
				}while(blk!=-1);
				display(freeblk);
				break;
		case 5: display(freeblk);

		} /* end of switch*/
	 }while(ch!=6); /*end of while */

}/* end of main function */

struct nodetype * createlist(struct nodetype *freeblk)
{
	printf("Enter block sizes and type -1 for termination\n");
	while(item!=-1)
	{
		scanf("%d",&item);
		if (item != -1)
		{
		   if (freeblk==NULL)
			{
			ptr = (struct nodetype *)malloc(sizeof(struct nodetype));
			freeblk=ptr;  /* freeblk now points to the first node of the list*/
			ptr->size=item;
			ptr->next=NULL;
			}
		     else
			{
			while(ptr->next!=NULL)
			    ptr = ptr->next;
			newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
			newnode->size = item;
			newnode->next =NULL;
			ptr->next =newnode;
			} /* End of Else structure */
	       } /* End of If structure */
	} /* end of outer while */
  return(freeblk);
} /* End of function createlist */

void display(struct nodetype *freeblk)
{
printf("\n List of free memory blocks");
ptr=freeblk;
while(ptr!=NULL)
{
printf("\n %d", ptr->size);
ptr = ptr->next;
}
}

void firstfit(int n)
{
	struct nodetype *p, *q;
	int s;
	p = freeblk;	/* assign the first block address from free list to variable pointer p */
	alloc = NULL;
	q = NULL;
	while ((p != NULL) && (p->size <n))
	{
		q = p;
		p = p->next;
	} /* end of while */
	if (p!= NULL)		/*  check for a block large enough */
	{
	  s = p->size;
	  alloc = p + s -n;		/* alloc contain the address of the desired block */

	if (s == n)		/* remove the block from the free list */
	  if (q == NULL)
		freeblk = p->next;
	  else
		 q->next  = p->next;
	else			/* adjust the size of the remaining free block */
		p->size = s - n;
	   } /* end if */
} /* end function */

void bestfit(int n)
	{
	struct nodetype *p, *q, *r, *rq;
	int s, rsize=32676;
	p = freeblk;	/* assign the first block address from free list to variable pointer p */
	alloc = NULL;
	q = NULL;		/* q is one block behing p*/
	r = NULL;		/* r points to the desired block */
	rq = NULL;		/* rq is one block behind r */
	while (p != NULL)
	{

		if ((p->size >= n) &&(p->size <rsize))
		{
			r = p;
			rq = q;
			rsize = p->size;
		} /* end if */

		q = p;
		p = p->next;
	} /* end of while */
	if (r!= NULL)		/*  check for a block large enough */
	{
		alloc = r + rsize -n;	/* alloc contain the address of the desired block */
	  if (rsize == n)		/* remove the block from the free list */
		 if (rq == NULL)
			freeblk = r->next;
		 else
			 rq->next  = r->next;
	   else			/* adjust the size of the remaining free block */
		r->size = rsize - n;
	   } /* end if */
} /* end function */

void worstfit(int n)
{
	struct nodetype *p, *q, *r, *rq;
	int s, rsize = 0;
	p = freeblk;	/* assign the first block address from free list to variable pointer p */
	alloc = NULL;
	q = NULL;		/* q is one block behing p*/
	r = NULL;		/* r points to the desired block */
	rq = NULL;		/* rq is one block behind r */
	while (p != NULL)
	{
		if ((p->size >= n) &&(p->size >rsize))
		{
			r = p;
			rq = q;
			rsize = p->size;
		} /* end if */

		q = p;
		p = p->next;
	} /* end of while */
	if (r!= NULL)		/*  check for a block large enough */
	{
		alloc = r + rsize -n;	/* alloc contain the address of the desired block */
	  if (rsize == n)		/* remove the block from the free list */
		 if (rq == NULL)
			freeblk = r->next;
		 else
			 rq->next  = r->next;
	   else			/* adjust the size of the remaining free block */
		r->size = rsize - n;
	  } /* end if */
} /* end function */