/* Program multique.c perform insertion, deletion operation on a
multiple queues with priority which is implmented using array
queue structure. We have assumed four different priority processes define
MAXQUEUE =4 and maximum number of items in each queue is 5  */

#include<stdio.h>
#include<conio.h>
#define MAXSIZE 20
#define MAXQUEUE 4
struct queue{
	int items[MAXSIZE];
	int rear[MAXQUEUE];
	int front[MAXQUEUE];
}q;
void queueins(struct queue *,int,int);
int  queuedel(struct queue *);
void display(struct queue *);

void queueins(struct queue *q ,int x, int p)
{
/*check for queue full,if so give a warning message and return */
if (q->rear[p-1]==5*p -1)
 {
  printf("Queue with priority %d is full\n", p-1);
  return;
 }
else
{
/* check for queue empty, if so initialized front and rear pointer to zero. Otherwise increment rear pointer */
 if (q->front[p-1] == 5*(p-1)-1)
 { q->front[p-1] =5*(p-1); q->rear[p-1] = 5*(p-1);}
 else
   q->rear[p-1] = q->rear[p-1] +1 ;
 q->items[q->rear[p-1]] = x;
}
} /* End of queueins function */


int queuedel(struct queue *q)
 {
 int x, i;
/*check for queue empty, if so raise a warning message and return*/
  for (i=0;i<4;i++)
  {
	 if (q->front[i]== 5*i -1)
	      {
		 printf(" Queue with priority %d is empty\n",i+1);
		 continue;
	      }
	/*if both pointer at the same position then reset the queue to
	 empty position  otherwise increment front pointer by 1.*/
	 if (q->front[i] == q->rear[i])
		 { q->front[i] = 5 *i-1; q->rear[i] =5*i -1;}
	 else
	  {
	     x = q->items[q->front[i]];
	     q->front[i] = q->front[i] +1 ;
	   }
    printf("\n Items deleted from queue %d",  i+1);
    break;
  }
return x;

}

void display(struct queue *q)
 {
 int i,j;
 for(i=0;i<4; i++)
 {
  if (q->front[i] != -1)
  {
   printf("\n Items in queue with priority %d-> ", i+1);
   if (q->front[i] <= q->rear[i])
     for( j=q->front[i];j<=q->rear[i];j++)
	printf("%d   ",q->items[j]);
 }
 }
} /* end of display function */


void main()
 {
	int ch,t, i,prt;
	for(i=0;i<MAXQUEUE;i++)
	{
	 q.rear[i] = 5*i -1;
	 q.front[i] =5*i -1; /* Intially set all queues to empty */
	}
	do{
	printf("\n Operations on Multiple Queues To implement Priority ");
	printf(" \n 1. Insert \n 2. Delete\n 3. Display \n 4. Exit:\n");
	printf("\n Select operation ");
	scanf("%d",&ch);
	switch(ch)
	{
	 case 1: do{
		printf("\nEnter process number and its priority (1..4) [-1 -1 for termination]");
		scanf("%d%d",&t,&prt);
		if ((t != -1) &&((prt>0) && (prt<5)))
			queueins(&q,t,prt);
		else
			break;
		}while(1);
		 break;
	 case 2:
		 queuedel(&q);
		 break;
	 case 3:
		 display(&q);
		 break;
	 case 4:break;
	   }
  }while(ch<4);
 } /* end of main */


