/* Program evalpost.cpp for evaluating a postfix expression such as 2 3 +
gives 5. Here we have consider the numeric value is only digit and allowed
operations are addition, subtraction, division, multiplication and exponents.
For exponent operation we have ^(carot)  operator.*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include<conio.h>

#define MAXSIZE 80
#define TRUE 1
#define FALSE 0
double eval(char[]);
double pop(struct stack *);
void push(struct stack *, double);
int empty(struct stack *);
int isdigit(char);
double oper(int, double, double);

struct stack{
int top;
double items[MAXSIZE];
};

void main()
{
	char expr[MAXSIZE];
	int position = 0;
	clrscr();
	printf("\n Enter postfix expression: ");
	while((expr[position++] = getchar()) != '\n')
		;
	expr[--position] = '\0';
	printf("%s is the original postfix expression ", expr);
	printf("\n Result is: ");
	printf("\n%f", eval(expr));
	getch();
} /* end main */

double eval(char expr[])
{
	int c, position;
	double opndl, opnd2, value;
	struct stack opndstk;
	opndstk.top = -1;
	for (position = 0; (c = expr[position]) != '\0'; position++)
	if (c !=' ')
	{
	  if (isdigit(c))
		/* operand-- convert the character representation
		of the digit into double and push it onto  the stack */

		push(&opndstk, (double) (c-'0'));
	   else {
		/* operator */
		opnd2 = pop(&opndstk);
		opndl = pop(&opndstk);
		value = oper(c, opndl, opnd2);
		push(&opndstk, value);
		} /* end else */
	 } /*end of outer if */
	return(pop(&opndstk));
} /* end eval */

int isdigit(char symb)
{
	return(symb >= '0' && symb <= '9');
}

double oper(int symb, double opl, double op2)
{
	switch(symb) {
	case '+' : return (opl + op2);
	case '-' : return (opl - op2);
	case '*' : return (opl * op2);
	case '/' : return (opl / op2);
	case '^' : return (pow(opl, op2));
	default: printf("\n%s", "illegal operation");
		 return FALSE;
} /* end switch */
} /* end oper */

void push(struct stack *s, double d)
{
	if (s->top == MAXSIZE -1)
	{
		printf("%s", "stack overflow");
		exit(0);
	}
	else
		s->items[++(s->top)] = d;
	return;
} /* end of push function */

double pop(struct stack *s)
{
	if (empty(s))
	{
		printf("\n%s", "stack underflow");
		exit(0);
	}
	return(s->items[s->top--]);
} /* end of pop function */

int empty(struct stack *s)
{
	if (s->top == -1)
	  return (TRUE);
	else
	 return (FALSE);
} /*end of empty function */
