/* Program inpostfix.c for converting infix expression into a postfix expression . For example infix  2 + 3  is converting postfix 23+. Here all the single character operands in the initial infix string are digits. The functions used in the program are empty, pop , push isoperand, prcd and postfix */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include<conio.h>

#define MAXSIZE 80
#define TRUE 1
#define FALSE 0
void postfix(char *, char *);
char pop(struct stack *);
void push(struct stack *, char);
int empty(struct stack *);
int isoperand(char);
int prcd(char, char);
void popandtest(struct stack *, char *, int *);

struct stack{
int top;
double items[MAXSIZE];
};

void main()
{
	char infix[MAXSIZE];
	char postr[MAXSIZE];
	int position = 0;
	while((infix[position++] = getchar()) != '\n')
		;
	infix[--position] = '\0';
	printf("%s%s", "is the original postfix expression ", infix);
	postfix(infix,postr);
	printf("\n%s", postr);
} /* end main */

void postfix(char infix[], char postr[])
{
	int und, position, outpos =0;
	char symb, topsymb = '+';
	struct stack opstack;
	opstack.top = -1;        /* the empty stack */

	for (position = 0; (symb = infix[position]) != '\0'; position++)
	  if (isoperand(symb))
	   postr[outpos++] = symb;
	   else {
		popandtest(&opstack, &topsymb, &und);
		while (!und && prcd(topsymb, symb))
		{
			postr[outpos++] = topsymb;
			popandtest(&opstack, &topsymb, &und);
		} /* end of while */
		if (!und)
			push(&opstack, topsymb);
		if (und ||(symb !=')'))
			push(&opstack, symb);
		else
		   topsymb =pop(&opstack);
	} /* end else */
	while(!empty(&opstack))
		postr[outpos++] = pop(&opstack);
	postr[outpos] = '\0';
return;
} /* end postfix */

int isoperand(char symb)
{
	return(symb >= '0' && symb <= '9');
}

double oper(int symb, double opl, double op2)
{
	switch(symb) {
	case '+' : return (opl + op2);
	case '-' : return (opl - op2);
	case '*' : return (opl * op2);
	case '/' : return (opl / op2);
	case '^' : return (pow(opl, op2));
	default: printf("\n%s", "illegal operation");
		 return FALSE;
} /* end switch */
} /* end oper */

void push(struct stack *s, char d)
{
	if (s->top == MAXSIZE -1)
	{
		printf("%s", "stack overflow");
		exit(0);
	}
	else
		s->items[++(s->top)] = d;
	return;
} /* end of push function */

char pop(struct stack *s)
{
	if (empty(s))
	{
		printf("\n%s", "stack underflow");
		exit(0);
	}
	return(s->items[s->top--]);
} /* end of pop function */

int empty(struct stack *s)
{
	if (s->top == -1)
	  return (TRUE);
	else
	 return (FALSE);
} /*end of empty function */

void popandtest(struct stack *s, char *p, int *u)
{
	if (empty(s)) {
		*u = TRUE;
		return;
	} /*end if*/
	*u = FALSE;
	*p =s->items[s->top--];
	return;
}/* end popandtest */

int prcd(char x, char y)
{
	if ((x =='(') || (y=='('))
		return FALSE;
	if (y ==')')
		return TRUE;
}
