
/* Insert Nodes in AVL TREE */
/* AVLINSRT.Cpp */

# include<stdio.h>
# include<malloc.h>
# include<conio.h>

struct nodetype
{
	struct nodetype *lchild;
	int Info;
	struct nodetype *rchild;
	int bf;
};
struct nodetype *root, *ancestor, *paranc, *dnode, *pardnode ;
int  found;

void avlinsrt(int);
struct nodetype *avlsrch(int);
void leftbal(struct nodetype *);
void rightbal(struct nodetype *);
void rebal(struct nodetype *);
void btreedel(int);
void btsrch(int);
void delcaseA(struct nodetype *, struct nodetype *);
void delcaseB();
void display(struct nodetype *, int);

void main()
{
clrscr();
root = NULL;
dnode = NULL;
pardnode = NULL;
avlinsrt(6);
avlinsrt(8);
avlinsrt(3);
avlinsrt(10);
avlinsrt(7);
avlinsrt(1);
avlinsrt(12);

//avlinsrt(128);

printf("\nThe AVL tree with root %d is as follows", root->Info);
display(root,1);
btreedel(1);
printf("\nThe AVL tree after deletion with root %d is as follows", root->Info);
display(root,1);

}
void avlinsrt(int x)
{
struct nodetype *newnode, *p, *q, *b;
int d, unbal;
if (root ==NULL)
{
newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
newnode->Info =x;
newnode->lchild =NULL;
newnode->rchild =NULL;
newnode->bf =0;
root  =newnode;
}
else
{
q = avlsrch(x);
	if (!found)
	{
	/* Insert and rebalance. x is not in tree and may be inserted as the
	appropriate child of q */
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->Info =x;
	newnode->lchild =NULL;
	newnode->rchild =NULL;
	newnode->bf =0;
	if ( x <q->Info)
		q->lchild = newnode;
	else
		q->rchild = newnode;
	/* Adjust balance factors of nodes on path from ancestor to q. Note that by
	the definition of ancestor, all nodes on this path must have balance factors
	of 0 and so will change to -+1. The value of d = +1 implies x is inserted
	in left subtree of ancestor, and d = -1 implies x is inserted in right subtree
	of ancestor. */
	if (x > ancestor->Info)
	{
		p = ancestor->rchild;
		b = p;
		d = -1;
	}
	else
	{
		p = ancestor->lchild;
		b = p;
		d = +1;
	}
	while (p!= newnode)
	{
		if (x >p->Info)
		{
			p->bf = -1; p = p->rchild;
		}
		else
		{
			p->bf = +1; p = p->lchild;
		}
	 }   /* end of while loop */
	 /* [Is tree unbalanced] */
	unbal = 1;
	if (ancestor->bf == 0)
	{	ancestor->bf = d;	unbal = 0;	}
	if (ancestor->bf + d ==0)
	{	ancestor->bf = 0;	unbal = 0;	}
	if (unbal)	/* tree unbalanced, determine rotation type */
	{
		if ( d == +1)	/* Left imbalance */
				leftbal(b);
		else
		if ( d == -1)	/* Right imbalance */
					rightbal(b);
		/* Subtree with root b has been rebalanced and is the new subtree */
	 } /* end of if unbal */
   } /* end of if not found */
} /* end of root = NULL */
} /* End of function avlinsrt */
struct nodetype *avlsrch(int x)
{
struct nodetype *p;
struct nodetype *q;
p = root;  q = NULL;
paranc = NULL;	ancestor = root;  found = 0;
	while ((p!=NULL)&& (!found))
	{
		if (p->bf !=0)
		{	ancestor =p; paranc=q; }
		if (x <p->Info)
		{   q = p; 	p = p->lchild; }
		else if (x > p->Info)
			{	q = p; 	p = p->rchild;	}
			else
				{	found =1; }
	} /* End of While Loop */
return (q);
}
void leftbal(struct nodetype *b)
{
struct nodetype *c;
	if (b->bf == +1)    /* Rotation type left to left */
	{
		printf("\n Left to Left rotation");
		ancestor->lchild = b->rchild;
		b->rchild = ancestor;
		ancestor->bf = 0; 	b->bf = 0;
	 }
	 else
	 {
		printf("\n Left to Right rotation");
		c = b->rchild;
		b->rchild = c->lchild;
		ancestor->lchild = c->rchild;
		c->lchild = b;
		c->rchild = ancestor;
		switch (c->bf)
		{
			case +1: ancestor->bf = -1; /* Left to Right rotation for b */
					 b->bf = 0;
					 break;
			case -1: ancestor->bf = 0;  /* Left to Right rotation for c */
					 b->bf = 1;
					 break;
			case 0: ancestor->bf = 0;/* Left to Right rotation for ancestor */
					b->bf = 0;
					break;
		} /* end of switch structure */
		c->bf = 0;	b = c;	/* b is a new root */
  }/* end of else of b->bf = +1 */
  rebal(b);
} /* End of function leftbal */

void rightbal(struct nodetype *b)
{
struct nodetype *c;
	if (b->bf == -1)    /* Rotation type is right to right */
	{
		printf("\n Right to Right rotation");
		ancestor->rchild = b->lchild;
		b->lchild = ancestor;
		ancestor->bf = 0; 	b->bf = 0;
	}
	else
	{
		printf("\n Right to Left rotation");
		c = b->lchild;
		b->lchild = c->rchild;
		ancestor->rchild = c->lchild;
		c->rchild = b;
		c->lchild = ancestor;
		switch (c->bf)
		{
			case +1: ancestor->bf = -1; /* Right to Left rotation for b */
					 b->bf = 0;
					 break;
			case -1: ancestor->bf = 0;  /* Right to Left rotation for c */
					 b->bf = 1;
					 break;
			case 0: ancestor->bf = 0;  /* Right to left rotation for ancestor */
					b->bf = 0;
					break;
		} /* end of switch structure */
		c->bf = 0;	b = c;	/* b is a new root */
   }/* end of else of b->bf = -1 */
	 rebal(b);
} /* End of function rightbal */
void rebal(struct nodetype *b)
{
printf("\n %d par", paranc->Info);
		if ( paranc==NULL)
			root = b;
		else if ( ancestor == paranc->lchild)
				paranc->lchild = b;
			 else if (ancestor == paranc->rchild)
						paranc->rchild = b;
}

void btreedel(int x)
{
struct nodetype *b;
btsrch(x);
if(dnode==NULL)
	printf("\n not found");
if ((dnode->rchild !=NULL) && (dnode->lchild!=NULL))
	delcaseB();
else
   delcaseA(dnode, pardnode);
free(dnode);
ancestor = pardnode;
if ((ancestor->lchild ==NULL) && (ancestor->rchild == NULL))
	 ancestor->bf =0;
else
{
if (ancestor->bf == +1)
{
	b = ancestor->lchild;
	if ((b->lchild !=NULL) || (b->rchild !=NULL))
		leftbal(b);
}
if (ancestor->bf == -1)
{
	b = ancestor->rchild;
	if ((b->lchild !=NULL) || (b->rchild !=NULL))
		rightbal(b);
}
}
}
void btsrch(int x)
{
paranc = NULL;
dnode =root;
 while((dnode!=NULL) &&(dnode->Info !=x))
 {
 pardnode = dnode;
 if (dnode->Info >x)
	dnode = dnode->lchild;
 else
	 dnode = dnode->rchild;
 if ((dnode->lchild !=NULL) ||(dnode->rchild !=NULL))
	paranc = pardnode;

 }
 
}
void delcaseA(struct nodetype *dnode,struct nodetype *pardnode)
{
struct nodetype *child, *b;
if ((dnode->lchild ==NULL) &&(dnode->rchild==NULL))
	child = NULL;
else if ((dnode->lchild)!=NULL)
		child = dnode->lchild;
	else
		child = dnode->rchild;
if (pardnode !=NULL)
	if (dnode==pardnode->lchild)
			pardnode->lchild = child;
	else
		pardnode->rchild = child;
else
		root = child;

}
void delcaseB()
{
struct nodetype *p,*q, *succ, *parsucc;
p = dnode->rchild;
q = dnode;
while ((p->lchild) !=NULL)
{
	q = p;
	p = p->lchild;
}
succ = p;
parsucc = q;
delcaseA(succ, parsucc);

if (pardnode !=NULL)
	if (dnode == pardnode->lchild)
		pardnode->lchild = succ;
	else
	pardnode->rchild = succ;
else
	root = succ;
succ->lchild = dnode->lchild;
succ->rchild = dnode->rchild;

}

void display(struct nodetype *start, int t)
{
int i=1;
struct nodetype *ptr=start;
	if (ptr)
	{
		display (ptr->rchild,t+1);
		printf("\n");
		for(i=0;i<=t;i++)
			printf("    ");
		printf("%d<",ptr->Info);
		display (ptr->lchild, t+1);
	}
}
