/* Program tree.cpp construct a general tree. Program consists of insert, search, display, searchinfo, and recursive traversal function.  */
#include<stdio.h>
#include<conio.h>
#include<malloc.h>

struct treenode
{
	int info;
	struct treenode *son;
	struct treenode *next;
};


/* Search function, find the treenode by its value in the tree */
struct treenode *search(struct treenode *root,int val,int nnum)
{
	struct treenode *ret=NULL;
	if(root->info==val)
		return root;
	if(root->son!=NULL)
	{
		nnum++;
		ret=search(root->son,val,nnum+1);
	}
	if(root->next!=NULL)
	{
		nnum++;
		ret=search(root->next,val,nnum+1);
	}
 return ret;
} /* end of function */


/* searchinfo function, find the treenode by its value in the tree and return
1 for sussessful search and 0 for unsessucssful search*/
int searchinfo(struct treenode *root,int val,int nnum)
{
	int ret=0;
	if(root->info==val)
	{
		printf("Treenode found");
		return 1;
	}
	if(root->son!=NULL)
	{
		nnum++;
		ret=searchinfo(root->son,val,nnum+1);
	}
	if(root->next!=NULL)
	{
		nnum++;
		ret=searchinfo(root->next,val,nnum+1);
	}
 return ret;
} /* end of function */

/* Function insert the node into its proper position */
void insert(struct treenode *root)
{
	int finfo,val;
	struct treenode *ptr=NULL,*tmp;
	printf("\n\n Enter the Father info: ");
	scanf("%d",&finfo);
	ptr=search(root,finfo,0);
	if(ptr!=NULL)
	{
		if(ptr->son!=NULL)
		{
			ptr=ptr->son;
			while(ptr->next!=NULL)
				ptr=ptr->next;

			tmp=(struct treenode *)malloc(sizeof(struct treenode));
			printf("Enter the Node Info: ");
			scanf("%d",&val);
			tmp->info=val;
			tmp->next=NULL;
			tmp->son=NULL;
			ptr->next=tmp;
		}
	   else
		{
			tmp=(struct  treenode *)malloc(sizeof(struct treenode));
			printf("Enter the Node Info: ");
			scanf("%d",&val);
			tmp->info=val;
			tmp->next=NULL;
			tmp->son=NULL;
			ptr->son=tmp;
		}
	}
	else
	{
		printf(" Node not found!!!");
		getch();
	}
}   /* end of insert */


/* Function display the nodes in the tree */
void display(struct treenode *root, struct treenode *father,int nnum)
{

	if(root!=NULL)
	{
		if(father!=NULL)
			printf(" father node=  %d: child node = %d \n",father->info,root->info);
		else
			printf(" ROOT => %d \n",root->info);

	}
	if(root->son!=NULL)
	{
		nnum++;
		display(root->son,root,nnum);
	}
	if(root->next!=NULL)
		display(root->next,father,++nnum);
} /* end of display */

/* function traverse the nodes of tree as inorder */ 
void tintrav(struct treenode *t)
{
if (t)
{
	tintrav(t->son);
	printf("\t %d", t->info);
	tintrav(t->next);
}
}/* end of tintrav function */

/* function traverse the nodes of tree as preorder */ 
void tpretrav(struct treenode *t)
{
if (t)
{
	printf("\t %d", t->info);
	tintrav(t->son);
	tintrav(t->next);

}
}/* end of tpretrav function */

/* function traverse the nodes of tree as postorder */ 
void tpostrav(struct treenode *t)
{
if (t)
{

	tintrav(t->son);
	tintrav(t->next);
	printf("\t %d", t->info);

}
} /* end of tpostrav function */

/* function traverse the nodes of tree as backward inorder */ 
void tbintrav(struct treenode *t)
{
if (t)
{
	tintrav(t->next);
	printf("\t %d", t->info);
	tintrav(t->son);
}
}/* end of tbintrav function */

/* main function */
void main()
{
	struct treenode *root;
	int ch,val;
	root = NULL;  /* empty tree */
	do
	{
	printf("\n 1. Create Root.");
	printf("\n 2. Exit.");
	printf("\n\n Enter your choice: ");
	scanf("%d",&ch);
	switch(ch)
	{
	case 1:
		clrscr();
		printf("Enter root info: ");
		scanf("%d",&val);
		root=(struct treenode *)malloc(sizeof(struct treenode));
		root->info=val;
		root->next=NULL;
		root->son=NULL;
		do
		{
		clrscr();
		printf("\n 1. Insert node.");
		printf("\n 3. Search node.");
		printf("\n 3. Display Tree.");
		printf("\n 4. Inorder Traversal.");
		printf("\n 5. Preorder Traversal.");
		printf("\n 6. Postorder Traversal.");
		printf("\n 7. Backward Inorder Traversal.");
		printf("\n 8. Exit.");
		printf("\n\n Enter your choice: ");
		scanf("%d",&ch);
		switch(ch)
		{
		case 1:
			insert(root);
			break;
		case 2:
			printf("\n\n Enter the node info: ");
			scanf("%d",&val);
				if(!searchinfo(root,val,0))
					printf("\nNode not found");
			getch();
			break;

		case 3:
			display(root,NULL,0);
			getch();
			break;
		case 4:
			tintrav(root);
			getch();
			break;
		case 5:
			tpretrav(root);
			getch();
			break;
		case 6:
			tpostrav(root);
			getch();
			break;
		case 7:
			tbintrav(root);
			getch();
			break;

		case 8:
			break;

		default:
			printf("\n Wrong coihce!!!");
			getch();
		}
	  }while(ch!=8);
	ch=2;
	break;

	case 2:
		break;
	default:
		printf("\nWrong choice!!!");
		break;
  } /* end of outer switch */
 }while(ch!=2);
} /* end of main */




