/* Program bfs.cpp traverse a graph which in input in the form of adjacency
matrix in breadth first search non-recursive method. It uses the basic
concept of queue data structure */
# include<stdio.h>
# include<conio.h>
#define MAXSIZE 10
struct queue{
	int items[MAXSIZE];
	int rear;
	int front;
}q;
void queueins(struct queue *,int);
int  queuedel(struct queue *);
int  empty(struct queue *);
void adjmat(int[MAXSIZE][MAXSIZE], int);
void bfs(int[MAXSIZE][MAXSIZE],int,int);
void main()
{
	int  a[MAXSIZE][MAXSIZE], v,g;
	q.front =-1; q.rear = -1;    /* Initialize queue to empty */
	printf("enter number of vertices in graph\n");
	scanf("%d",&v);
	adjmat(a,v);
	printf("Enter start vertex [0-%d]\n",v-1);
	scanf("%d",&g);
	bfs(a,g,v );
	getch();
} /* end of main */

/* Input function */
void adjmat(int a[MAXSIZE][MAXSIZE], int n)
{
	int i, j;
	printf("\n Input adjacency matrix of order %dx%d\n",n,n);
	for(i =0; i < n; i++)
		for(j =0; j < n; j++)
			scanf("%d", &a[i][j]);
}

void bfs(int a[MAXSIZE][MAXSIZE], int g, int n)
{
	int i,j, visited[MAXSIZE],h;
	for(i=0;i<n;i++)
	visited[i] =0;
	h = g ;
	visited[h] = 1;
	printf("\n BFS sequence with start vertex is -> ");
	while(1)
	{
	printf(" %d ", h);
	 for (j = 0; j<n; j++)
	  {
		if ((a[h][j] == 1) && (visited[j] == 0))
			{
				queueins(&q, j);
				visited[j] = 1;
			}
	 }
		if (empty(&q))
			return;
		else
			h = queuedel(&q);

	} /* end of while */
} /* end BFS */


void queueins(struct queue *q ,int x)
{
/*check for queue full,if so give a warning message and return */

if (q->rear==MAXSIZE -1)
 {
  printf("Queue full\n");
  return;
 }
else
{
/* check for queue empty, if so initialized front and rear pointer to zero.
 Otherwise increment rear pointer*/
 if (q->front == -1)
 { q->front =0; q->rear = 0;}
 else
   q->rear = q->rear+1 ;
 q->items[q->rear] = x;
}
} /* End of queueins function */


int queuedel(struct queue *q)
 {
	int x;
	x = q->items[q->front];

/* if both pointer at the same position then reset the queue to empty position
 otherwise increment front pointer by 1.*/

	 if (q->front == q->rear)
	 { q->front = -1; q->rear =-1;}
	 else
	   q->front = q->front +1 ;
   return x;
}

int empty(struct queue *q)
{
	 if (q->front==-1)
		return 1;
	else
		return 0;
}

